<script lang="ts">
import Vue, { PropType } from 'vue';
import { SlpContainer, SlpColumn } from '../common/index.vue';
import CloseIcon from '~/static/nuxt-images/icons/close.vue';
import { FEATURES_HOSTING } from '~/common/constants';

export default Vue.extend({
  name: 'FeaturesFilter',
  components: { SlpColumn, CloseIcon, SlpContainer },
  props: {
    defaultCategory: {
      type: String,
      required: true,
    },
    dropdownOptions: {
      type: Array as PropType<Array<string>>,
      required: false,
      default: () => [],
    },
    dropdownLabel: {
      type: String,
      required: true,
    },
  },
  data() {
    return {
      plan: '',
      hosting: '',
      category: this.defaultCategory,
      planOptions: ['Free', 'Premium', 'Ultimate'],
      hostingOptions: [FEATURES_HOSTING.saas, FEATURES_HOSTING.self_managed],
    };
  },
  computed: {
    filterCount() {
      let count = 0;

      if (this.plan !== '' && this.hosting !== '') {
        count = 2;
      } else if (this.plan !== '' || this.hosting !== '') {
        count = 1;
      }

      return count;
    },
  },
  watch: {
    defaultCategory() {
      this.category = this.defaultCategory;
    },
  },
  mounted() {
    this.$watch(
      () => ({
        plan: this.plan,
        hosting: this.hosting,
        category: this.category,
      }),
      () => {
        this.updateFilter();
      },
      {},
    );
  },
  methods: {
    resetFilter() {
      this.plan = '';
      this.hosting = '';
    },
    updateFilter() {
      this.$emit('updateFilter', {
        plan: this.plan,
        hosting: this.hosting,
        category: this.category,
      });
    },
  },
});
</script>

<template>
  <SlpContainer
    class="features-filter"
    data-aos="fade-up"
    data-aos-duration="500"
  >
    <SlpRow class="features-filter__row">
      <SlpColumn :cols="4">
        <SlpDropdown
          v-model="category"
          :dropdown-label="dropdownLabel"
          class="features-filter__dropdown"
          :options="dropdownOptions"
          name="category"
        />
      </SlpColumn>
      <div class="slp-flex slp-align-items-center">
        <VDropdown :distance="6">
          <a class="features-filter__button"
            ><SlpTypography variant="body1" tag="span">
              Filter by Plan & Hosting set-up
              {{ filterCount ? `(${filterCount})` : '' }}
            </SlpTypography></a
          >

          <template #popper="{ hide }">
            <div class="features-filter__popover">
              <div class="features-filter__close">
                <button @click="hide()">
                  <CloseIcon />
                </button>
              </div>
              <div class="features-filter__content">
                <SlpTypography
                  class="slp-mb-8 slp-color-surface-400"
                  variant="all-caps"
                  tag="h3"
                  >Available on
                </SlpTypography>
                <SlpRadioGroup
                  v-model="plan"
                  :options="planOptions"
                  name="plan"
                ></SlpRadioGroup>
                <SlpTypography
                  class="slp-mb-8 slp-color-surface-400"
                  variant="all-caps"
                  tag="h3"
                  >Hosting set-up
                </SlpTypography>
                <SlpRadioGroup
                  v-model="hosting"
                  :options="hostingOptions"
                  name="hosting"
                ></SlpRadioGroup>
              </div>
              <div class="features-filter__reset">
                <button @click="resetFilter">Reset</button>
              </div>
            </div>
          </template>
        </VDropdown>
      </div>
    </SlpRow>
  </SlpContainer>
</template>

<style scoped lang="scss">
.features-filter {
  margin-bottom: $spacing-32;
  padding: $spacing-16 $spacing-8;
  border-bottom: 1px solid $color-surface-200;
  border-top: 1px solid $color-surface-200;

  @media (min-width: $breakpoint-md) {
    border: none;
  }

  &__row {
    flex-direction: column;

    @media (min-width: $breakpoint-md) {
      flex-direction: row;
    }
  }

  &__close {
    display: flex;
    justify-content: flex-end;

    button {
      cursor: pointer;
      border: none;

      &:hover {
        filter: brightness(80%);
      }
    }

    &::v-deep svg {
      fill: $color-surface-700;
    }
  }

  &__button {
    cursor: pointer;
    color: $color-primary-200;

    &:hover {
      filter: brightness(80%);
    }
  }

  &__dropdown {
    margin-bottom: $spacing-8;

    &::v-deep .dropdown__select {
      border-radius: 68px;
      padding-left: $spacing-24;
      font-weight: $font-weight-bold;
    }

    @media (min-width: $breakpoint-md) {
      margin-right: $spacing-16;
      margin-bottom: 0;
    }

    &:after {
      @media (min-width: $breakpoint-md) {
        top: 12px;
      }
    }
  }

  &__popover {
    padding: $spacing-16;
    min-width: 300px;
  }

  &__content {
    border-bottom: 1px solid $color-surface-200;
  }

  &__reset {
    display: flex;
    justify-content: center;
    align-items: center;
    padding-top: $spacing-16;

    button {
      border: none;
      color: $color-text-link-100;
      cursor: pointer;
      font-size: $text-body-1;
      transition: all 0.4s ease-in-out;

      &:hover {
        opacity: 0.7;
      }
    }
  }

  &::v-deep .v-popper {
    @media (max-width: $breakpoint-md) {
      width: 100%;
    }
  }
}
</style>
